package com.tomtom.business.ubi.sample;

import com.google.firebase.messaging.FirebaseMessagingService;
import com.google.firebase.messaging.RemoteMessage;

import android.util.Log;

/**
 * Called after the mobile device received a push notification issued by TomTom's WEBFLEET server. 
 * At the moment these push notifications are sent when a user hasn't uploaded UBI data for a couple of days. 
 *
 * Copyright (c) 2016 TomTom Telematics, all rights reserved.
 */
public class SampleFcmListenerService extends FirebaseMessagingService
{
    private static final String LOG_TAG = SampleFcmListenerService.class.getName();

    @Override
    public void onMessageReceived(RemoteMessage message)
    {
        //the key that is sent is always 'action'
        //the value is 'uploadHint'
        String action = message.getData().get("action");
        Log.i(LOG_TAG, "Got PN via FCM via WFM, action = '" + action + "'");
    }
}
