## Installation & Project Setup

The ZIP file contains the OBD.connect SDK libraries (`mobileubicoreextlib`-directory) and a Sample application (`app`-directory) as Android Studio project.

You can use the OBD.connect libraries in your own app by copying the `mobileubicoreextlib`-directory to your Android app project directory
and adding this Android library module as compile-time dependency in your Gradle project setup.

## Documentation

Javadoc API documentation is included in the SDK ZIP file.

## Sample App

Import the Sample App into Android Studio.
All necessary dependencies are resolved by Gradle during the import.
Please generate a proper `google-services.json` (found in the `app`-directory) via <https://console.firebase.google.com/> for your copy of the sample app to use the FCM in combination with the OBD.connect SDK.
Also replace the login data with your WEBFLEET credentials of the `CoreBootParameter` objects before building the app.
After a Gradle sync the app can be build as usual with Android Studio.

## Connections

For testing purposes please use the following parameters to connect to WEBFLEET:

* WEBFLEET Messaging Server Host Name: `its-robin-gprs.business.tomtom.com`
* WEBFLEET Messaging Server Port: `443`
* WEBFLEET.connect Server Host URI: `https://its-wfc.business.tomtom.com`
* WEBFLEET.connect API Key: `UBI-ROBIN-SINGLEOBJECT`

When you are done with testing and want to switch to production environment please use the following parameters to connect to WEBFLEET:

* WEBFLEET Messaging Server Host Name: `robin-gprs.business.tomtom.com`
* WEBFLEET Messaging Server Port: `443`
* WEBFLEET.connect Server Host URI: `https://csv.business.tomtom.com`
* WEBFLEET.connect API Key: `handed to the sdk user on a per-company basis`

See `CoreBootParameter` for details.

## Known Issues
	
## Definition of Terms

The following terms are used in the documentation with following meaning:

* **device** always means the device talking to the smartphone, like a LINK100 UBI. The term 'LINK', 'LINK device' and 'LINK100' are equivalent.
* **TomTom UBI Service** the combination of a backend service and a LINK100 device to deliver services for UBI. The term 'service' is used as equivalent.

## Release Notes

### 1.4.1

* bug fixes

### 1.4.0

* improve firmware update availability request handling on boot
* removed unused permissions
* updated SDK to use Android SDK 25

### 1.3.0

* improved firmware update process and extended SDK documentation with firmware update state machine
* updated SDK to use latest Android SDK 23
* updated SDK and sample app to use FCM instead of GCM

### 1.2.3

* reduce amount of messages when initiating sync too often via `ServiceClient.startSync()`

### 1.2.1/1.2.2

* added missing dependencies in Gradle config of OBD.connect library

### 1.2.0

* removed GCM registration from SDK library, the application now has to do the GCM registration and provide the GCM parameters
  via `ServiceClient.sendGcmRegistrationToken`
* fixed wrong handling of parallel firmware updates.
* Bugfix for missing error reporting on failed data upload in case of delayed transmission or slow server processing. 
  Error is now reported via a call to `ServiceClientCallback.onDownloadStatusUpdate(DownloadStatusResponse response)` (`DownloadProgressState` of the response object is set to `FAILED`)

New features when used with LINK 100 Firmware 1.5 or newer:

* Real time profile data feed – see see `ServiceClientCallback.onDrivingProfileRealTimeDatagram`. 
  This allows an application to provide real time feedback about the driving performance/driving score. The profile data is reset after a 
  downtime (engine off) of more than two hours.
* Engine status notifications – see `ServiceClientCallback.onEngineStatusUpdate`. 
  Using this callback, the application can be notified by the SDK about engine on/off events. Note that - depending on the vehicle - the engine off 
  notification might only be reported up to 10 seconds after the vehicle's engine is turned off
* extended OBD real time feed, see `ObdRealTimeDatagram`. Additional values are only delivered if supported by the vehicle.

	
